(*
 * Coq code for "A Translation from Typed Assebmly Language to
 *                                  Certified Assembly Programming"
 *
 * Sample lemmas (pseudo rules) for load/store of mutable reference cell
 *
 * (for Coq version 8)
 *)

Require Import Eqdep.
Require Import natutil.
Require Import Map.
Require Import Mapt.
Require Import tm.
Require Import axiom.
Require Import xcapiuw.

Definition insens (a : Assertion) r :=
  forall Si Fi H R, Itp (a (H, R)) Si Fi -> forall w, Itp (a (H, uR R r w)) Si Fi.

Lemma wld : forall Si a t rd rs w I,
  (Si |-{ fun S => a S ./\ t (_R S rd) } I) -> insens a rd ->
  (Si |-{ fun S => a S ./\ ref _ (_R S rs + w) t } iseq (ld rd rs w) I).
intros. apply wfiseq with (fun S => a S ./\ t (_R S rd)); auto.
clear H I; intros; destruct s; destruct H; destruct H; destruct H; destruct H.
destruct H1; destruct H2; destruct (okvalid _ _ _ H2); clear H2; simpl in *.
generalize (okvalid _ _ _ H5); clear H5; intros; simpl in *.
destruct (H3 (r rs + w) (fun S => t S)); destruct (H5 H2); clear H5 H6 H8.
destruct H7; destruct H5.
exists (o, uR r rd x2); split.
apply stp_ld; rewrite <- H1; apply lookup_disj_merge_lookup_2; auto.
exists x; exists x0; exists x1; split; auto; split; auto; split; auto.
unfold Itp; apply ok_and_i. apply H0; auto.
unfold uR; rewrite beq_req_true; auto.
Qed.

Lemma wst : forall Si a t rd w rs I,
(Si |-{ a } I) ->
(Si |-{ fun S => a S ./\ ref _ (_R S rd + w) t
                     ./\ t (_R S rs)           } iseq (st rd w rs) I).
intros; apply wfiseq with a; auto.
clear H I; intros; destruct s; destruct H; destruct H; destruct H; destruct H.
destruct H0; destruct H1; destruct (okvalid _ _ _ H1); clear H1; simpl in *.
destruct (okvalid _ _ _ H4); clear H4; simpl in *.
generalize (okvalid _ _ _ H1); clear H1; simpl in *; intros.
destruct (H2 (r rd + w) (fun S => t S)); destruct (H4 H1); clear H4 H6 H8.
destruct H7; destruct H4.
exists (uH o (r rd + w) (r rs), r); split.
apply stp_st with x2; auto; rewrite <- H0.
apply lookup_disj_merge_lookup_2; auto.
exists x; exists x0; exists (uH x1 (r rd + w) (r rs)); split.
unfold Map.disjoint; intro; generalize (H a0); destruct (x0 a0); auto.
compare (r rd + w) a0; intros.
rewrite e in H4; rewrite H4 in H7; tauto.
unfold uH; rewrite <- beq_neq_false; auto.
split.
rewrite <- H0; apply ext_eq; intros.
compare (r rd + w) x3; intros.
unfold uH. rewrite <- beq_eq_true; auto.
rewrite e in H4.
cut (Map.not_in_dom x0 x3); intros.
unfold Map.not_in_dom in H7; unfold Map.merge; rewrite H7.
rewrite <- beq_eq_true; auto.
apply Map.indom_disj_notindom with x1.
exists x2; auto.
apply Map.disj_sym; auto.
rewrite Map.disj_merge_sym.
unfold Map.merge at 1; unfold uH.
rewrite <- beq_neq_false; auto.
rewrite Map.disj_merge_sym; auto.
unfold Map.disjoint; intro; generalize (H a0); destruct (x0 a0); auto.
compare (r rd + w) a0; intros.
rewrite e in H4; rewrite H4 in H7; tauto.
unfold uH; rewrite <- beq_neq_false; auto.
split; auto.
unfold DH; intros; destruct (H2 l t0); split.
intros; destruct (H7 H9); destruct H10; destruct H10.
split; auto.
compare (r rd + w) l; intros.
exists (r rs); split.
unfold Map.lookup, uH; rewrite <- beq_eq_true; auto.
rewrite e in H1; unfold lookup in H1; unfold lookup in H9.
rewrite H1 in H9; inversion H9; unfold Itp; auto.
exists x3; split; auto.
unfold Map.lookup, uH; rewrite <- beq_neq_false; auto.
intros; destruct H9.
compare (r rd + w) l; intros.
rewrite e in H1; exists (fun S => t S); auto.
unfold uH in H9; rewrite <- beq_neq_false in H9; auto.
apply H8; exists x3; auto.
Qed.